{
  open Parselia
}
rule token = parse
    [' ' '\t']+ { token lexbuf }
  | '\n' { Lexing.new_line lexbuf;  EOL }
  | eof { EOF }
  | "|" { OR }
  | "<=" { LEQ }
  | '=' { EQ }
  | "!=" { NEQ }
  | ">=" { GEQ }
  | '<' { LS }
  | '>' { GR }
  | '+' { PLUS }
  | '-' { MINUS }
  | ['a'-'z''A'-'Z''_']['a'-'z''A'-'Z''_''0'-'9']* as s { VAR(s) }
  | ['+''-']?['0'-'9']+ as s { CTE(int_of_string s) }
