let _ =
  let lexbuf = Lexing.from_channel stdin in
  try
    let result = Parselia.prob Lexlia.token lexbuf in
    Smt.print_prob stdout result
  with
    Parsing.Parse_error ->
      let open Lexing in
      Printf.eprintf "Parsing error line %i characters %i to %i.\n"
	lexbuf.lex_start_p.pos_lnum
	(lexbuf.lex_start_p.pos_cnum - lexbuf.lex_start_p.pos_bol)
	(lexbuf.lex_curr_p.pos_cnum - lexbuf.lex_start_p.pos_bol);
      exit 1

