%{
  open Smt
%}
%token<int> CTE
%token<string> VAR
%token EOL EOF OR LEQ EQ NEQ GEQ LS GR PLUS MINUS 
%start prob  
%type<Smt.prob> prob
%%
prob : clause EOL prob { $1 @ $3 }
| EOF { [] }
;
clause : lit OR clause { distrib $1 $3 }
| lit { $1 }
;
lit : poly LEQ poly {
  let s, c = minus_poly $1 $3 in
  [[Leq (s, -c)]]
}
| poly EQ poly {
  let s, c = minus_poly $1 $3 in
  [[Leq (s, -c)];[Gr(s, -c - 1)]]
}
| poly NEQ poly {
  let s, c = minus_poly $1 $3 in
  [[Leq(s, -c - 1); Gr(s, -c)]]
}
| poly GEQ poly {
  let s, c = minus_poly $1 $3 in
  [[Gr (s, -c - 1)]]
}
| poly LS poly {
  let s, c = minus_poly $1 $3 in
  [[Leq (s, -c - 1)]]
}
| poly GR poly {
  let s, c = minus_poly $1 $3 in
  [[Gr (s, -c)]]
}
;
poly : term { $1 }
| term PLUS poly { plus_poly $1 $3 }
| term MINUS poly { minus_poly $1 $3 }
;
term: CTE { SM.empty, $1 }
| VAR { SM.singleton $1 1, 0}
| MINUS VAR { SM.singleton $2 (-1), 0}
| CTE VAR { SM.singleton $2 $1, 0}
;   
